import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.common.util.dtd.elements.DTDDataType;
import quadbase.common.util.internal.XMLFieldInfo;
import quadbase.common.util.internal.XMLFileQueryInfo;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;

public class MailingLabels extends Applet {
	static final long serialVersionUID = 1;

	public static void main(java.lang.String[] args) {

		try {

			MailingLabels doReport = new MailingLabels();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", doReport.doMailingLabelsReport(frame));
			frame.setSize(1080, 800);
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);

		} catch (Exception ex) {

			ex.printStackTrace();

		}

	}

	@Override
	public void init() {

		setLayout(new BorderLayout());
		add("Center", doMailingLabelsReport(this));

	}

	Component doMailingLabelsReport(Object parent) {
		QbReport.setEspressManagerUsed(false);

		String xmlfilename = "Inventory.xml";
		String dtdfilename = "Inventory.dtd";
		String xmlcondition = "/Inventory/Category/Product/UnitsInStock < 15";

		XMLFieldInfo[] fields = new XMLFieldInfo[8];
		fields[0] = new XMLFieldInfo(new String[] { "Inventory", "Category" }, "CategoryName");
		fields[1] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product" },
				"ProductID");
		fields[2] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product",
				"ProductName" });

		fields[3] = new XMLFieldInfo(
				new String[] { "Inventory", "Category", "Product", "UnitPrice" });
		fields[3].setElementDataType(DTDDataType.DOUBLE);

		fields[4] = new XMLFieldInfo(
				new String[] { "Inventory", "Category", "Product", "Material" });
		fields[5] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product", "Material",
				"Units" });
		fields[5].setElementDataType(DTDDataType.INT);

		fields[6] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product", "Material",
				"CostPerUnit" });
		fields[6].setElementDataType(DTDDataType.DOUBLE);

		fields[7] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product",
				"UnitsInStock" });
		fields[7].setElementDataType(DTDDataType.INT);

		XMLFileQueryInfo xmlInfo = new XMLFileQueryInfo(xmlfilename, fields, xmlcondition, fields,
				dtdfilename, false, null);

		ColInfo[] colInfo = new ColInfo[8];
		for (int i = 0; i < 8; i++) {
			colInfo[i] = new ColInfo(i);
		}

		QbReport report = new QbReport
				(parent, // Parent
						QbReport.MAILINGLABELS, // Type of Report
						xmlInfo, // XML Info
						colInfo, // Column Mapping
						null, // Template Name
						false); // Side By Side 

		try {
			//			 Apply Template with Formula and Script
			report.applyTemplate("MailingLabels.rpt", true);

		} catch (Exception e) {
			e.printStackTrace();
		}
		return (new Viewer().getComponent(report));

	}
}
